#ifndef PERMISSIONSERVICE_H
#define PERMISSIONSERVICE_H

#include "service.h"
#include "permission.h"
#include "core-odb.hxx"
#include "core_global.h"
#include <odb/core.hxx>
#include <odb/database.hxx>
#include <odb/query.hxx>
#include <odb/result.hxx>

#include <QList>
#include <QSharedPointer>
#include <QString>

typedef odb::query<Permission> permQuery;
typedef odb::result<Permission> permResult;

class CORESHARED_EXPORT PermissionService : public Service<Permission>
{
public:
    PermissionService();
    ~PermissionService();

    QList<QSharedPointer<Permission> > forPlugin(const QString &pluginId);
    QSharedPointer<Permission> forNameAndPlugin(const QString &name, const QString &pluginId);
};

#endif // PERMISSIONSERVICE_H
